## osmium-tool 1.1.1

=== CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool
#
#-----------------------------------------------------------------------------

cmake_minimum_required(VERSION 2.8 FATAL_ERROR)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)


#-----------------------------------------------------------------------------
#
#  Project version
#
#-----------------------------------------------------------------------------

set(CMAKE_CONFIGURATION_TYPES "Debug;Release;RelWithDebInfo;MinSizeRel;Dev"
    CACHE STRING
    "List of available configuration types"
    FORCE)

project(osmium)

set(OSMIUM_VERSION_MAJOR 1)
set(OSMIUM_VERSION_MINOR 1)
set(OSMIUM_VERSION_PATCH 1)

set(OSMIUM_VERSION ${OSMIUM_VERSION_MAJOR}.${OSMIUM_VERSION_MINOR}.${OSMIUM_VERSION_PATCH})

add_definitions(-DOSMIUM_VERSION="${OSMIUM_VERSION}")

set(AUTHOR "Jochen Topf <jochen@topf.org>")


#-----------------------------------------------------------------------------
#
#  Find external dependencies
#
#-----------------------------------------------------------------------------

find_package(Boost REQUIRED COMPONENTS program_options)
include_directories(${Boost_INCLUDE_DIRS})

find_package(Osmium REQUIRED COMPONENTS io)
include_directories(${OSMIUM_INCLUDE_DIRS})


#-----------------------------------------------------------------------------
#
#  Optional "cppcheck" target that checks C++ code
#
#-----------------------------------------------------------------------------
message(STATUS "Looking for cppcheck")
find_program(CPPCHECK cppcheck)

if(CPPCHECK)
    message(STATUS "Looking for cppcheck - found")
    set(CPPCHECK_OPTIONS --enable=warning,style,performance,portability,information,missingInclude)

    # cpp doesn't find system includes for some reason, suppress that report
    set(CPPCHECK_OPTIONS ${CPPCHECK_OPTIONS} --suppress=missingIncludeSystem)

    add_custom_target(cppcheck ${CPPCHECK} --std=c++11 ${CPPCHECK_OPTIONS} ${CMAKE_SOURCE_DIR}/src/*pp)
else()
    message(STATUS "Looking for cppcheck - not found")
    message(STATUS "  Make target cppcheck not available")
endif(CPPCHECK)


#-----------------------------------------------------------------------------
#
#  Optional "man" target to generate man pages
#
#-----------------------------------------------------------------------------
message(STATUS "Looking for pandoc")
find_program(PANDOC pandoc)

function(add_man_page _section _name)
    file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/man/man${_section})
    set(_output_file ${CMAKE_BINARY_DIR}/man/man${_section}/${_name}.${_section})
    set(_source_file ${CMAKE_SOURCE_DIR}/man/${_name}.md)
    set(_install_dir "share/man/man{$_section}")
    string(TOUPPER ${_name} _name_upcase)
    add_custom_command(OUTPUT ${_output_file}
        COMMAND ${PANDOC}
            ${PANDOC_MAN_OPTIONS}
            --variable "title=${_name_upcase}"
            --variable "section=${_section}"
            -o ${_output_file}
            ${_source_file}
        DEPENDS ${_source_file} man/manpage.template
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        COMMENT "Building manpage ${_name}.${_section}"
        VERBATIM)
    set(ALL_MAN_PAGES "${ALL_MAN_PAGES};${_output_file}" PARENT_SCOPE)
endfunction()


if(PANDOC)
    message(STATUS "Looking for pandoc - found")
    message(STATUS "  Manual pages will be built")
    set(PANDOC_MAN_OPTIONS
        -s
        -t man
        --template ${CMAKE_CURRENT_SOURCE_DIR}/man/manpage.template
        --variable "description=osmium/${OSMIUM_VERSION}"
        --variable "version=${OSMIUM_VERSION}"
        --variable "author=${AUTHOR}"
    )
    set(PANDOC_HTML_OPTIONS -s -t html)

    add_man_page(1 osmium)
    add_man_page(1 osmium-apply-changes)
    add_man_page(1 osmium-cat)
    add_man_page(1 osmium-check-refs)
    add_man_page(1 osmium-fileinfo)
    add_man_page(1 osmium-getid)
    add_man_page(1 osmium-merge-changes)
    add_man_page(1 osmium-renumber)
    add_man_page(1 osmium-time-filter)
    add_man_page(5 osmium-file-formats)

    install(DIRECTORY ${CMAKE_BINARY_DIR}/man DESTINATION share)

    add_custom_target(man ALL DEPENDS ${ALL_MAN_PAGES})
else()
    message(STATUS "Looking for pandoc - not found")
    message(STATUS "  Manual pages will not be built")
endif(PANDOC)


#-----------------------------------------------------------------------------
#
#  Decide which C++ version to use (Minimum/default: C++11).
#
#-----------------------------------------------------------------------------
if(NOT MSVC)
    if(NOT USE_CPP_VERSION)
        set(USE_CPP_VERSION c++11)
    endif()
    message(STATUS "Use C++ version: ${USE_CPP_VERSION}")
    # following only available from cmake 2.8.12:
    #   add_compile_options(-std=${USE_CPP_VERSION})
    # so using this instead:
    add_definitions(-std=${USE_CPP_VERSION})
endif()


#-----------------------------------------------------------------------------
#
#  Compiler and Linker flags
#
#-----------------------------------------------------------------------------
if(MSVC)
    set(USUAL_COMPILE_OPTIONS "/Ox")
else()
    set(USUAL_COMPILE_OPTIONS "-O3 -g")
endif()

if(WIN32)
    add_definitions(-DWIN32 -D_WIN32 -DMSWIN32 -DBGDWIN32
                    -DWINVER=0x0500 -D_WIN32_WINNT=0x0500 -D_WIN32_IE=0x0600)
endif()

set(CMAKE_CXX_FLAGS_DEV "${USUAL_COMPILE_OPTIONS}"
    CACHE STRING "Flags used by the compiler during developer builds."
    FORCE)

set(CMAKE_EXE_LINKER_FLAGS_DEV ""
    CACHE STRING "Flags used by the linker during developer builds."
    FORCE)
mark_as_advanced(
    CMAKE_CXX_FLAGS_DEV
    CMAKE_EXE_LINKER_FLAGS_DEV
)

set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${USUAL_COMPILE_OPTIONS}"
    CACHE STRING "Flags used by the compiler during RELWITHDEBINFO builds."
    FORCE)


#-----------------------------------------------------------------------------
#
#  Build Type
#
#-----------------------------------------------------------------------------

# In 'Dev' mode: compile with very strict warnings and turn them into errors.
if(CMAKE_BUILD_TYPE STREQUAL "Dev")
    if(NOT MSVC)
        add_definitions(-Werror)
    endif()
    add_definitions(${OSMIUM_WARNING_OPTIONS})
endif()

# Force RelWithDebInfo build type if none was given
if(CMAKE_BUILD_TYPE)
    set(build_type ${CMAKE_BUILD_TYPE})
else()
    set(build_type "RelWithDebInfo")
endif()

set(CMAKE_BUILD_TYPE ${build_type}
    CACHE STRING
    "Choose the type of build, options are: ${CMAKE_CONFIGURATION_TYPES}."
    FORCE)


#-----------------------------------------------------------------------------

configure_file(
    ${PROJECT_SOURCE_DIR}/osmium-wrapper.in
    ${PROJECT_BINARY_DIR}/osmium
)


#-----------------------------------------------------------------------------
#
#  Tests
#
#-----------------------------------------------------------------------------

enable_testing()
add_subdirectory(test)

#-----------------------------------------------------------------------------

include_directories(include)
include_directories(${PROJECT_BINARY_DIR}/src)

add_subdirectory(src)


#-----------------------------------------------------------------------------

=== test/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests
#
#-----------------------------------------------------------------------------

function(do_test _name _command _regex)
    separate_arguments(_command)
    add_test(NAME ${_name} COMMAND ${_command})
    set_tests_properties(${_name} PROPERTIES
                         ENVIRONMENT "MANPATH=${PROJECT_BINARY_DIR}/man"
                         PASS_REGULAR_EXPRESSION ${_regex}
    )
endfunction()

#-----------------------------------------------------------------------------

function(check_output _name _command _output)
    set(_cmd "${PROJECT_BINARY_DIR}/src/osmium ${_command}")
    add_test(
        NAME ${_name}
        COMMAND ${CMAKE_COMMAND}
        -Dcmd=${_cmd}
        -Ddir=${PROJECT_SOURCE_DIR}/test
        -Dreference=${_output}
        -P ${CMAKE_SOURCE_DIR}/cmake/run_test_compare_output.cmake
    )
endfunction()

function(check_output2 _name _command1 _command2 _output)
    set(_cmd1 "${PROJECT_BINARY_DIR}/src/osmium ${_command1}")
    set(_cmd2 "${PROJECT_BINARY_DIR}/src/osmium ${_command2}")
    add_test(
        NAME ${_name}
        COMMAND ${CMAKE_COMMAND}
        -Dcmd=${_cmd1}
        -Dcmd2=${_cmd2}
        -Ddir=${PROJECT_SOURCE_DIR}/test
        -Dreference=${_output}
        -P ${CMAKE_SOURCE_DIR}/cmake/run_test_compare_output.cmake
    )
endfunction()

#-----------------------------------------------------------------------------

add_subdirectory(cat)
add_subdirectory(check-refs)
add_subdirectory(getid)
add_subdirectory(fileinfo)
add_subdirectory(help)
add_subdirectory(renumber)
add_subdirectory(time-filter)


#-----------------------------------------------------------------------------

=== test/cat/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - cat
#
#-----------------------------------------------------------------------------

function(check_cat _name _in1 _in2 _output)
    check_output(cat-${_name} "cat --generator=test -f osm cat/${_in1} cat/${_in2}" "cat/${_output}")
endfunction()

#-----------------------------------------------------------------------------

check_cat(cat12 input1.osm input2.osm output-cat12.osm)
check_cat(cat21 input2.osm input1.osm output-cat21.osm)


#-----------------------------------------------------------------------------

=== test/fileinfo/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - fileinfo
#
#-----------------------------------------------------------------------------

function(check_fileinfo _name _options _input _output)
    check_output(fileinfo-${_name} "fileinfo ${_options} fileinfo/${_input}" "fileinfo/${_output}")
endfunction()

#-----------------------------------------------------------------------------

check_fileinfo(fi1 "--extended" fi1.osm fi1-result.txt)


#-----------------------------------------------------------------------------

=== test/getid/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - getid
#
#-----------------------------------------------------------------------------

function(check_getid _name _input _output)
    check_output(getid-${_name} "getid --generator=test -f osm getid/${_input} n11,n12 w21" "getid/${_output}")
endfunction()

check_getid(n input.osm output.osm)

#-----------------------------------------------------------------------------

=== test/help/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - help
#
#-----------------------------------------------------------------------------

do_test(version  "osmium --version" "^osmium version ${OSMIUM_VERSION}\n")
do_test(help     "osmium help"      "^Usage: .*Commands are:")
do_test(help2    "osmium --help"    "^Usage: .*Commands are:")

if(PANDOC)
    do_test(help_cat "osmium help cat" "^OSMIUM-CAT\\(1\\)")
endif()


#-----------------------------------------------------------------------------

=== test/renumber/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - renumber
#
#-----------------------------------------------------------------------------

function(check_renumber _name _input _output)
    check_output(renumber-${_name} "renumber --generator=test -f osm renumber/${_input}" "renumber/${_output}")
endfunction()

function(check_renumber2 _name _in1 _in2 _out)
    set(_idxdir "${PROJECT_BINARY_DIR}/test/renumber/index")
    file(REMOVE_RECURSE ${_idxdir})
    file(MAKE_DIRECTORY ${_idxdir})
    check_output2(renumber-${_name}
                  "renumber --index-directory=${_idxdir} --generator=test -f osm --overwrite -o /dev/null renumber/${_in1}"
                  "renumber --index-directory=${_idxdir} --generator=test -f osc renumber/${_in2}"
                  "renumber/${_out}"
    )
endfunction()

check_renumber(sorted input-sorted.osm output-sorted.osm)

check_renumber2(change input-sorted.osm input-change.osc output-change.osc)

#-----------------------------------------------------------------------------

=== test/time-filter/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - time-filter
#
#-----------------------------------------------------------------------------

function(check_time_filter _name _type _from _to _output)
    check_output(time-filter-${_name} "time-filter --generator=test -f ${_type} time-filter/input.osh ${_from} ${_to}" "time-filter/output-${_output}.${_type}")
endfunction()

#-----------------------------------------------------------------------------

check_time_filter(last osm ""                   "" last)
check_time_filter(ts1  osm 2015-01-01T01:00:00Z "" ts1)
check_time_filter(ts1a osm 2015-01-01T01:01:00Z "" ts1)
check_time_filter(ts2  osm 2015-01-01T02:00:00Z "" ts2)
check_time_filter(ts2a osm 2015-01-01T02:01:00Z "" ts2)
check_time_filter(ts3  osm 2015-01-01T03:00:00Z "" ts3)
check_time_filter(ts3a osm 2015-01-01T03:01:00Z "" ts3)

check_time_filter(range-0-5   osh 2015-01-01T00:00:00Z 2015-01-01T05:00:00Z range-0-5)
check_time_filter(range-1-2   osh 2015-01-01T01:00:00Z 2015-01-01T02:00:00Z range-1-2)
check_time_filter(range-1a-2a osh 2015-01-01T01:01:00Z 2015-01-01T02:01:00Z range-1a-2a)
check_time_filter(range-2-3   osh 2015-01-01T02:00:00Z 2015-01-01T03:00:00Z range-2-3)
check_time_filter(range-2-3a  osh 2015-01-01T02:00:00Z 2015-01-01T03:01:00Z range-2-3a)
check_time_filter(range-2-4   osh 2015-01-01T02:00:00Z 2015-01-01T04:00:00Z range-2-4)


#-----------------------------------------------------------------------------

=== debian/changelog ===
osmium-tool (1.1.1-2build1) wily; urgency=medium

  * No-change rebuild against libprotobuf-lite9v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 10 Aug 2015 17:39:57 +0000

osmium-tool (1.1.1-2) unstable; urgency=medium

  * Add patch to fix test failure on big endian architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 21 Jul 2015 21:56:07 +0200

osmium-tool (1.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Add license & copyright for RapidJSON includes.
  * Drop reproducible-build.patch, fixed upstream.
  * Require at least libosmium version 2.2.0.
  * Add lintian override for license-problem-json-evil false positive.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 21 Jul 2015 07:43:37 +0200

osmium-tool (1.0.1-2) unstable; urgency=medium

  * Add patch by Chris Lamb for reproducible build.
    (closes: #790087)
  * Handle other extensions in filenamemangle.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 27 Jun 2015 11:11:47 +0200

osmium-tool (1.0.1-1) unstable; urgency=medium

  * Initial release (Closes: #779938)

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 23 Jun 2015 21:34:31 +0200

=== debian/control ===
Source: osmium-tool
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               libboost-dev,
               libboost-program-options-dev,
               libbz2-dev,
               libexpat1-dev,
               libosmium2-dev (>= 2.2.0),
               libosmpbf-dev,
               libprotobuf-dev,
               protobuf-compiler,
               pandoc,
               zlib1g-dev
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/cgit/pkg-grass/osmium-tool.git/
Vcs-Git: git://anonscm.debian.org/pkg-grass/osmium-tool.git
Homepage: http://osmcode.org/osmium/

Package: osmium-tool
Architecture: any
Section: utils
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Command line tool for working with OpenStreetMap data
 Osmium Tool is a multipurpose command line tool based on the Osmium library.
 .
 With the Osmium Tool you currently can:
 .
  * Get information about an OSM file
  * Convert OSM files from one format into another (supports all XML and PBF
    formats)
  * Merge and apply change files to an OSM file (with or without history)
  * Extract data from OSM history files for a given point in time or a time
    range
 .
 The Osmium library has extensive support for all types of OSM entities: nodes,
 ways, relations, and changesets. It allows reading from and writing to OSM
 files in XML and PBF formats, including change files and full history files.
 Osmium can store OSM data in memory and on disk in various formats and using
 various indexes. Its easy to use handler interface allows you to quickly write
 data filtering and conversion functions. Osmium can create WKT, WKB, OGR, GEOS
 and GeoJSON geometries for easy conversion into many GIS formats and it can
 assemble multipolygons from ways and relations.

## osmium-tool 1.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -26,8 +26,8 @@
 project(osmium)
 
 set(OSMIUM_VERSION_MAJOR 1)
-set(OSMIUM_VERSION_MINOR 1)
-set(OSMIUM_VERSION_PATCH 1)
+set(OSMIUM_VERSION_MINOR 3)
+set(OSMIUM_VERSION_PATCH 0)
 
 set(OSMIUM_VERSION ${OSMIUM_VERSION_MAJOR}.${OSMIUM_VERSION_MINOR}.${OSMIUM_VERSION_PATCH})
 
@@ -43,7 +43,7 @@
 #-----------------------------------------------------------------------------
 
 find_package(Boost REQUIRED COMPONENTS program_options)
-include_directories(${Boost_INCLUDE_DIRS})
+include_directories(SYSTEM ${Boost_INCLUDE_DIRS})
 
 find_package(Osmium REQUIRED COMPONENTS io)
 include_directories(${OSMIUM_INCLUDE_DIRS})
@@ -121,6 +121,7 @@
     add_man_page(1 osmium-getid)
     add_man_page(1 osmium-merge-changes)
     add_man_page(1 osmium-renumber)
+    add_man_page(1 osmium-sort)
     add_man_page(1 osmium-time-filter)
     add_man_page(5 osmium-file-formats)

=== Makefile ===

all:
	mkdir -p build && cd build && cmake .. && $(MAKE)

clean:
	if test -d build; then cd build && $(MAKE) clean; fi

distclean:
	rm -fr build

deb:
	debuild -I -us -uc

.PHONY: clean distclean deb

=== src/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool
#
#-----------------------------------------------------------------------------

file(GLOB OSMIUM_SOURCE_FILES *.cpp)

add_executable(osmium ${OSMIUM_SOURCE_FILES})

target_link_libraries(osmium ${Boost_LIBRARIES} ${CRYPTOPP_LIBRARIES} ${OSMIUM_LIBRARIES})

install(TARGETS osmium DESTINATION bin)

=== test/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests
#
#-----------------------------------------------------------------------------

include_directories(include)
include_directories(../src)
include_directories(../include)

file(GLOB ALL_SETUP_TESTS */test_setup.cpp)
file(GLOB ALL_COMMANDS ../src/command_*.cpp ../src/io.cpp ../src/cmd_factory.cpp)
add_executable(unit_tests unit_tests.cpp ${ALL_COMMANDS} ${ALL_SETUP_TESTS})
target_link_libraries(unit_tests ${Boost_LIBRARIES} ${OSMIUM_LIBRARIES})
add_test(NAME unit_tests COMMAND unit_tests)


#-----------------------------------------------------------------------------

configure_file(io/Makefile.in ${CMAKE_CURRENT_BINARY_DIR}/io/Makefile @ONLY)

#-----------------------------------------------------------------------------

function(do_test _name _command _regex)
    separate_arguments(_command)
    add_test(NAME ${_name} COMMAND ${_command})
    set_tests_properties(${_name} PROPERTIES
                         ENVIRONMENT "MANPATH=${PROJECT_BINARY_DIR}/man"
                         PASS_REGULAR_EXPRESSION ${_regex}
    )
endfunction()

#-----------------------------------------------------------------------------

function(check_output _dir _name _command _reference)
    set(_cmd "$<TARGET_FILE:osmium> ${_command}")
    add_test(
        NAME "${_dir}-${_name}"
        COMMAND ${CMAKE_COMMAND}
        -D cmd:FILEPATH=${_cmd}
        -D dir:PATH=${PROJECT_SOURCE_DIR}/test
        -D reference:FILEPATH=${PROJECT_SOURCE_DIR}/test/${_reference}
        -D output:FILEPATH=${PROJECT_BINARY_DIR}/test/${_dir}/cmd-output-${_name}
        -P ${CMAKE_SOURCE_DIR}/cmake/run_test_compare_output.cmake
    )
endfunction()

function(check_output2 _dir _name _command1 _command2 _reference)
    set(_cmd1 "$<TARGET_FILE:osmium> ${_command1}")
    set(_cmd2 "$<TARGET_FILE:osmium> ${_command2}")
    add_test(
        NAME "${_dir}-${_name}"
        COMMAND ${CMAKE_COMMAND}
        -D cmd:FILEPATH=${_cmd1}
        -D cmd2:FILEPATH=${_cmd2}
        -D dir:PATH=${PROJECT_SOURCE_DIR}/test
        -D reference:FILEPATH=${PROJECT_SOURCE_DIR}/test/${_reference}
        -D output:FILEPATH=${PROJECT_BINARY_DIR}/test/${_dir}/cmd-output-${_name}
        -P ${CMAKE_SOURCE_DIR}/cmake/run_test_compare_output.cmake
    )
endfunction()


#-----------------------------------------------------------------------------
#
#  Configure tests in all subdirectories
#
#-----------------------------------------------------------------------------

file(GLOB _testcmakes "test" "*/CMakeLists.txt")

foreach(_tc IN LISTS _testcmakes)
    string(REPLACE "/CMakeLists.txt" "" _dir ${_tc})
    message(STATUS "Adding tests in ${_dir}")
    add_subdirectory(${_dir})
endforeach()


#-----------------------------------------------------------------------------

=== test/apply-changes/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - apply-changes
#
#-----------------------------------------------------------------------------

function(check_apply_changes _name _options _input _change _type _output)
    check_output(apply-changes ${_name} "apply-changes ${_options} --generator=test -f ${_type} apply-changes/${_input} apply-changes/${_change}" "apply-changes/${_output}")
endfunction()

check_apply_changes(withhist "" input-data.osm input-change.osc "osh" output.osh)
check_apply_changes(simplified "--simplify --remove-deleted" input-data.osm input-change.osc "osm" simplified.osm)


#-----------------------------------------------------------------------------

=== test/cat/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - cat
#
#-----------------------------------------------------------------------------

function(check_cat _name _in1 _in2 _output)
    check_output(cat ${_name} "cat --generator=test -f osm cat/${_in1} cat/${_in2}" "cat/${_output}")
endfunction()

function(check_convert _name _input _output _format)
    check_output(cat ${_name} "cat --generator=test cat/${_input} -f ${_format}" "cat/${_output}")
endfunction()


#-----------------------------------------------------------------------------

check_cat(cat12 input1.osm input2.osm output-cat12.osm)
check_cat(cat21 input2.osm input1.osm output-cat21.osm)

check_convert(osm2opl input1.osm output1.osm.opl opl)


#-----------------------------------------------------------------------------

=== test/check-refs/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - check-refs
#
#-----------------------------------------------------------------------------

add_test(NAME check-ref-nwr-okay COMMAND osmium check-refs -r ${CMAKE_SOURCE_DIR}/test/check-refs/nwr-okay.osm)
add_test(NAME check-ref-nw-okay COMMAND osmium check-refs ${CMAKE_SOURCE_DIR}/test/check-refs/nw-okay.osm)


#-----------------------------------------------------------------------------

=== test/fileinfo/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 #-----------------------------------------------------------------------------
 
 function(check_fileinfo _name _options _input _output)
-    check_output(fileinfo-${_name} "fileinfo ${_options} fileinfo/${_input}" "fileinfo/${_output}")
+    check_output(fileinfo ${_name} "fileinfo ${_options} fileinfo/${_input}" "fileinfo/${_output}")
 endfunction()
 
 #-----------------------------------------------------------------------------

=== test/getid/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 #-----------------------------------------------------------------------------
 
 function(check_getid _name _input _output)
-    check_output(getid-${_name} "getid --generator=test -f osm getid/${_input} n11,n12 w21" "getid/${_output}")
+    check_output(getid ${_name} "getid --generator=test -f osm getid/${_input} n11,n12 w21" "getid/${_output}")
 endfunction()
 
 check_getid(n input.osm output.osm)

=== test/help/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - help
#
#-----------------------------------------------------------------------------

do_test(help1 "osmium"        "^Usage: .*Commands are:")
do_test(help2 "osmium help"   "^Usage: .*Commands are:")
do_test(help3 "osmium --help" "^Usage: .*Commands are:")
do_test(help4 "osmium -h"     "^Usage: .*Commands are:")

if(PANDOC)
    do_test(help_cat "osmium help cat" "^OSMIUM-CAT\\(1\\)")
endif()

do_test(help_topic_unknown "osmium help x" "^Unknown help topic 'x'.\n")


#-----------------------------------------------------------------------------

=== test/misc/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - misc
#
#-----------------------------------------------------------------------------

do_test(version1 "osmium --version" "^osmium version ${OSMIUM_VERSION}\n")
do_test(version2 "osmium version"   "^osmium version ${OSMIUM_VERSION}\n")

do_test(unknown_command "osmium x" "^Unknown command 'x'. Try 'osmium help'.\n")


#-----------------------------------------------------------------------------

=== test/renumber/CMakeLists.txt ===
--- 
+++ 
@@ -7,15 +7,20 @@
 #-----------------------------------------------------------------------------
 
 function(check_renumber _name _input _output)
-    check_output(renumber-${_name} "renumber --generator=test -f osm renumber/${_input}" "renumber/${_output}")
+    check_output(renumber ${_name} "renumber --generator=test -f osm renumber/${_input}" "renumber/${_output}")
 endfunction()
 
 function(check_renumber2 _name _in1 _in2 _out)
     set(_idxdir "${PROJECT_BINARY_DIR}/test/renumber/index")
     file(REMOVE_RECURSE ${_idxdir})
     file(MAKE_DIRECTORY ${_idxdir})
-    check_output2(renumber-${_name}
-                  "renumber --index-directory=${_idxdir} --generator=test -f osm --overwrite -o /dev/null renumber/${_in1}"
+    if(WIN32)
+        set(_devnull "nul")
+    else()
+        set(_devnull "/dev/null")
+    endif()
+    check_output2(renumber ${_name}
+                  "renumber --index-directory=${_idxdir} --generator=test -f osm --overwrite -o ${_devnull} renumber/${_in1}"
                   "renumber --index-directory=${_idxdir} --generator=test -f osc renumber/${_in2}"
                   "renumber/${_out}"
     )

=== debian/changelog ===
osmium-tool (1.3.0-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 05 Dec 2015 14:21:36 +0100

osmium-tool (1.3.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Bump minimum required libosmium2-dev to 2.5.3.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 18 Nov 2015 22:57:28 +0100

osmium-tool (1.2.1-2) unstable; urgency=medium

  * Don't ignore test failures any more, all fixed upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 02 Sep 2015 16:53:52 +0200

osmium-tool (1.2.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump minimum required libosmium2-dev to 2.4.1.
  * Update Vcs-Browser URL to use HTTPS.
  * Drop big-endian-fileinfo-test.patch, fixed upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 31 Aug 2015 16:15:53 +0200

osmium-tool (1.2.0-2) unstable; urgency=medium

  * Restore big-endian-fileinfo-test.patch, not fixed upstream.
  * Ignore test failures to not fail the entire build.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 23 Aug 2015 11:55:32 +0200

osmium-tool (1.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Drop build dependencies on osmpbf & protobuf.
  * Bump minimum required libosmium2-dev to 2.3.0.
  * Update copyright file, add license & copyright for catch.hpp.
  * Drop patches, fixed upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 21 Aug 2015 21:05:48 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: osmium-tool
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
+Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Bas Couwenberg <sebastic@debian.org>
 Section: science
 Priority: optional
@@ -10,14 +9,11 @@
                libboost-program-options-dev,
                libbz2-dev,
                libexpat1-dev,
-               libosmium2-dev (>= 2.2.0),
-               libosmpbf-dev,
-               libprotobuf-dev,
-               protobuf-compiler,
+               libosmium2-dev (>= 2.5.3),
                pandoc,
                zlib1g-dev
 Standards-Version: 3.9.6
-Vcs-Browser: http://anonscm.debian.org/cgit/pkg-grass/osmium-tool.git/
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/osmium-tool.git/
 Vcs-Git: git://anonscm.debian.org/pkg-grass/osmium-tool.git
 Homepage: http://osmcode.org/osmium/

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Verbose make output
export VERBOSE=1

%:
	dh $@ --buildsystem cmake \
	      --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_VERBOSE_MAKEFILE=1

override_dh_installchangelogs:
	dh_installchangelogs -k CHANGELOG.md

=== debian/watch ===
version=3
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
filenamemangle=s/(?:.*)?v(\d[\d\.]*)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/osmium-tool-$1.$2/ \
https://github.com/osmcode/osmium-tool/releases \
(?:.*/)?(?:rel|v|osmium-tool)[\-\_]?(\d[\d\-\.]+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## osmium-tool 1.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,7 +27,7 @@
 
 set(OSMIUM_VERSION_MAJOR 1)
 set(OSMIUM_VERSION_MINOR 3)
-set(OSMIUM_VERSION_PATCH 0)
+set(OSMIUM_VERSION_PATCH 1)
 
 set(OSMIUM_VERSION ${OSMIUM_VERSION_MAJOR}.${OSMIUM_VERSION_MINOR}.${OSMIUM_VERSION_PATCH})
 
@@ -83,7 +83,11 @@
     file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/man/man${_section})
     set(_output_file ${CMAKE_BINARY_DIR}/man/man${_section}/${_name}.${_section})
     set(_source_file ${CMAKE_SOURCE_DIR}/man/${_name}.md)
-    set(_install_dir "share/man/man{$_section}")
+    set(_dest_file ${CMAKE_BINARY_DIR}/man-source/${_name}.md)
+    file(READ ${CMAKE_SOURCE_DIR}/man/common-options.md MAN_COMMON_OPTIONS)
+    file(READ ${CMAKE_SOURCE_DIR}/man/input-options.md MAN_INPUT_OPTIONS)
+    file(READ ${CMAKE_SOURCE_DIR}/man/output-options.md MAN_OUTPUT_OPTIONS)
+    configure_file(${_source_file} ${_dest_file} @ONLY)
     string(TOUPPER ${_name} _name_upcase)
     add_custom_command(OUTPUT ${_output_file}
         COMMAND ${PANDOC}
@@ -91,8 +95,8 @@
             --variable "title=${_name_upcase}"
             --variable "section=${_section}"
             -o ${_output_file}
-            ${_source_file}
-        DEPENDS ${_source_file} man/manpage.template
+            ${_dest_file}
+        DEPENDS ${_source_file} man/manpage.template man/common-options.md man/input-options.md man/output-options.md
         WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
         COMMENT "Building manpage ${_name}.${_section}"
         VERBATIM)
@@ -116,11 +120,13 @@
     add_man_page(1 osmium)
     add_man_page(1 osmium-apply-changes)
     add_man_page(1 osmium-cat)
+    add_man_page(1 osmium-changeset-filter)
     add_man_page(1 osmium-check-refs)
     add_man_page(1 osmium-fileinfo)
     add_man_page(1 osmium-getid)
     add_man_page(1 osmium-merge-changes)
     add_man_page(1 osmium-renumber)
+    add_man_page(1 osmium-show)
     add_man_page(1 osmium-sort)
     add_man_page(1 osmium-time-filter)
     add_man_page(5 osmium-file-formats)
@@ -193,7 +199,7 @@
 # In 'Dev' mode: compile with very strict warnings and turn them into errors.
 if(CMAKE_BUILD_TYPE STREQUAL "Dev")
     if(NOT MSVC)
-        add_definitions(-Werror)
+        add_definitions(-Werror -Wno-unused-variable)
     endif()
     add_definitions(${OSMIUM_WARNING_OPTIONS})
 endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 
 add_executable(osmium ${OSMIUM_SOURCE_FILES})
 
-target_link_libraries(osmium ${Boost_LIBRARIES} ${CRYPTOPP_LIBRARIES} ${OSMIUM_LIBRARIES})
+target_link_libraries(osmium ${Boost_LIBRARIES} ${OSMIUM_LIBRARIES})
 
 install(TARGETS osmium DESTINATION bin)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 include_directories(../include)
 
 file(GLOB ALL_SETUP_TESTS */test_setup.cpp)
-file(GLOB ALL_COMMANDS ../src/command_*.cpp ../src/io.cpp ../src/cmd_factory.cpp)
+file(GLOB ALL_COMMANDS ../src/command_*.cpp ../src/io.cpp ../src/cmd.cpp ../src/cmd_factory.cpp)
 add_executable(unit_tests unit_tests.cpp ${ALL_COMMANDS} ${ALL_SETUP_TESTS})
 target_link_libraries(unit_tests ${Boost_LIBRARIES} ${OSMIUM_LIBRARIES})
 add_test(NAME unit_tests COMMAND unit_tests)
@@ -47,7 +47,7 @@
     )
 endfunction()
 
-function(check_output2 _dir _name _command1 _command2 _reference)
+function(check_output2 _dir _name _tmpdir _command1 _command2 _reference)
     set(_cmd1 "$<TARGET_FILE:osmium> ${_command1}")
     set(_cmd2 "$<TARGET_FILE:osmium> ${_command2}")
     add_test(
@@ -56,11 +56,34 @@
         -D cmd:FILEPATH=${_cmd1}
         -D cmd2:FILEPATH=${_cmd2}
         -D dir:PATH=${PROJECT_SOURCE_DIR}/test
+        -D tmpdir:PATH=${_tmpdir}
         -D reference:FILEPATH=${PROJECT_SOURCE_DIR}/test/${_reference}
         -D output:FILEPATH=${PROJECT_BINARY_DIR}/test/${_dir}/cmd-output-${_name}
         -P ${CMAKE_SOURCE_DIR}/cmake/run_test_compare_output.cmake
     )
 endfunction()
+
+
+#-----------------------------------------------------------------------------
+#
+#  Check "osmium SUBCOMMAND -h" for most subcommands.
+#
+#-----------------------------------------------------------------------------
+function(check_cmd_help _command)
+    do_test(help_cmd_${_command} "osmium ${_command} -h" "Usage: osmium ${_command}.*OPTIONS:")
+endfunction()
+
+check_cmd_help(apply-changes)
+check_cmd_help(cat)
+check_cmd_help(changeset-filter)
+check_cmd_help(check-refs)
+check_cmd_help(fileinfo)
+check_cmd_help(getid)
+check_cmd_help(merge-changes)
+check_cmd_help(renumber)
+check_cmd_help(show)
+check_cmd_help(sort)
+check_cmd_help(time-filter)
 
 
 #-----------------------------------------------------------------------------

=== test/misc/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 do_test(version1 "osmium --version" "^osmium version ${OSMIUM_VERSION}\n")
 do_test(version2 "osmium version"   "^osmium version ${OSMIUM_VERSION}\n")
 
-do_test(unknown_command "osmium x" "^Unknown command 'x'. Try 'osmium help'.\n")
+do_test(unknown_command "osmium x" "^Unknown command or option 'x'. Try 'osmium help'.\n")
 
 
 #-----------------------------------------------------------------------------

=== test/renumber/CMakeLists.txt ===
--- 
+++ 
@@ -12,14 +12,12 @@
 
 function(check_renumber2 _name _in1 _in2 _out)
     set(_idxdir "${PROJECT_BINARY_DIR}/test/renumber/index")
-    file(REMOVE_RECURSE ${_idxdir})
-    file(MAKE_DIRECTORY ${_idxdir})
     if(WIN32)
         set(_devnull "nul")
     else()
         set(_devnull "/dev/null")
     endif()
-    check_output2(renumber ${_name}
+    check_output2(renumber ${_name} ${_idxdir}
                   "renumber --index-directory=${_idxdir} --generator=test -f osm --overwrite -o ${_devnull} renumber/${_in1}"
                   "renumber --index-directory=${_idxdir} --generator=test -f osc renumber/${_in2}"
                   "renumber/${_out}"
@@ -31,3 +29,23 @@
 check_renumber2(change input-sorted.osm input-change.osc output-change.osc)
 
 #-----------------------------------------------------------------------------
+
+# input data not ordered properly
+
+add_test(NAME renumber-fail-order-n COMMAND osmium renumber ${CMAKE_SOURCE_DIR}/test/order/fail-order-n.osm -f osm)
+set_tests_properties(renumber-fail-order-n PROPERTIES WILL_FAIL true)
+
+add_test(NAME renumber-fail-order-w COMMAND osmium renumber ${CMAKE_SOURCE_DIR}/test/order/fail-order-w.osm -f osm)
+set_tests_properties(renumber-fail-order-w PROPERTIES WILL_FAIL true)
+
+add_test(NAME renumber-fail-order-r COMMAND osmium renumber ${CMAKE_SOURCE_DIR}/test/order/fail-order-r.osm -f osm)
+set_tests_properties(renumber-fail-order-r PROPERTIES WILL_FAIL true)
+
+add_test(NAME renumber-fail-order-wn COMMAND osmium renumber ${CMAKE_SOURCE_DIR}/test/order/fail-order-wn.osm -f osm)
+set_tests_properties(renumber-fail-order-wn PROPERTIES WILL_FAIL true)
+
+add_test(NAME renumber-fail-order-rw COMMAND osmium renumber ${CMAKE_SOURCE_DIR}/test/order/fail-order-rw.osm -f osm)
+set_tests_properties(renumber-fail-order-rw PROPERTIES WILL_FAIL true)
+
+
+#-----------------------------------------------------------------------------

=== debian/changelog ===
osmium-tool (1.3.1-1) unstable; urgency=medium

  * New upstream release.
  * Update copyright file, update copyright years for Jochen Topf.
  * Drop spelling-errors.patch, applied upstream.
  * Add patch to fix 'output' typo.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 08 Jun 2016 21:23:37 +0200

osmium-tool (1.3.0-2) unstable; urgency=medium

  * Update Vcs-Git URL to use HTTPS.
  * Bump Standards-Version to 3.9.8, no changes.
  * Update watch file to handle more tag conventions in filenamemangle.
  * Enable all hardening buildflags.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 01 Jun 2016 17:44:22 +0200

=== debian/control ===
--- 
+++ 
@@ -12,9 +12,9 @@
                libosmium2-dev (>= 2.5.3),
                pandoc,
                zlib1g-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/osmium-tool.git/
-Vcs-Git: git://anonscm.debian.org/pkg-grass/osmium-tool.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-grass/osmium-tool.git
 Homepage: http://osmcode.org/osmium/
 
 Package: osmium-tool

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,9 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+
+# Enable hardening build flags
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 # Verbose make output
 export VERBOSE=1
